/********************************************************************* 
 *
 *  Gmsh convection
 * 
 *  Variables, elementary entities (points, lines, surfaces), physical
 *  entities (points, lines, surfaces)
 *
 *********************************************************************/
lc = 0.0002;
nm=1.0e-7 ; 
wirewidth=60;
oxidethick=10;
height=wirewidth+oxidethick;
Nwire=40;
Noxide=10;
Point(1) = {0, 0, 0, lc};
Point(2) = {wirewidth*nm, 0, 0, lc} ;
Point(3) = {wirewidth*nm, wirewidth*nm, 0, lc} ;
Point(4) = {0, wirewidth*nm, 0, lc} ;

Point(5) = {-oxidethick*nm, 0, 0, lc} ;
Point(6) = {-oxidethick*nm, wirewidth*nm, 0, lc} ;
Point(7) = {-oxidethick*nm, height*nm, 0, lc} ;
Point(8) = {0*nm, height*nm, 0, lc} ;
Point(9) = {wirewidth*nm, height*nm, 0, lc} ;
Point(10) = {height*nm, height*nm, 0, lc} ;
Point(11) = {height*nm, wirewidth*nm, 0, lc} ;
Point(12) = {height*nm, 0*nm, 0, lc} ;





Line(1) = {1, 4};
Line(2) = {4, 3};
Line(3) = {3, 2};
Line(4) = {2, 1};
Line(5) = {1, 5};
Line(6) = {5, 6};
Line(7) = {6, 4};
Line(8) = {6, 7};
Line(9) = {7, 8};
Line(10) = {8, 4};
Line(11) = {8, 9};
Line(12) = {9, 3};
Line(13) = {9, 10};
Line(14) = {10, 11};
Line(15) = {11, 3};
Line(16) = {11, 12};
Line(17) = {12, 2};

Transfinite Line{1,6,2,3,4,11,16}=Nwire; 
Transfinite Line{5,7,9,8,10,12,13,14,15,17}=Noxide; 


Line Loop(18) = {2, 3, 4, 1};

Plane Surface(1) = {18};
//+
Line Loop(20) = {1, -7, -6, -5};
//+
Plane Surface(2) = {20};
//+
Line Loop(22) = {10, -7, 8, 9};
//+
Plane Surface(3) = {22};
//+
Line Loop(24) = {11, 12, -2, -10};
//+
Plane Surface(4) = {24};
//+
Line Loop(26) = {13, 14, 15, -12};
//+
Plane Surface(5) = {26};
//+
Line Loop(28) = {16, 17, -3, -15};
//+
Plane Surface(6) = {28};

Transfinite Surface{1,2,3,4,5,6};

Extrude {0, 0, 120*nm} {
    Surface{1,2,3,4,5,6}; Layers{20};
  }
Extrude {0, 0, -20*nm} {
    Surface{1}; Layers{10};
  }
Extrude {0, 0, 20*nm} {
    Surface{50}; Layers{10};
  }
Extrude {0, 0, -50*nm} {
    Surface{182}; Layers{10};
  }
Extrude {0, 0, 50*nm} {
    Surface{204}; Layers{10};
  }

Physical Surface(1) = {67,89,93,103,125,129,147};//gate
Physical Surface(2) = {239,235,247};//drain
Physical Surface(3) = {213,217,225};//source





Physical Volume(1) = {2,3,4,5,6};  //oxide
Physical Volume(2) = {1,8,7};  // channel
Physical Volume(3) = {9};  // drain
Physical Volume(4) = {10};  // source










